#pragma once
#include "sdh.h"
#include "dsa.h"
#include "util.h"
#include "sdhlibrary_settings.h"
#include "basisdef.h"
#include "sdhoptions.h"
#include "SensorHit.h"
using namespace System;
using namespace std;
using namespace SDH;
using namespace System::Windows::Forms;
using namespace System::Collections;
using namespace System::Threading;
using namespace System::IO;

ref class SDHBackend
{
public:
	
	double alpha_max, beta_max;
	cSDH *hand;
	cDSA * dsa;
	cSDHOptions * options;
	ArrayList ^printBuffer;
	Thread ^graspingThread, ^openHandThread, ^closeGraspThread, ^proximalsThread, ^distalsThread;
	bool noHits, running, moving;
	SensorHit ^lastHit;
	int iMaxPressure;
	int iPressureThreshhold;
	ArrayList ^ sensorHits;
	bool inhibitAxis1, inhibitAxis3, inhibitAxis5, proximalsDetected;
	bool isFullAuto;
	int activeAxis;
	TextWriter ^tw;
	int iGrabVelocity;
	double fingerDelta;
	String ^state;
	ArrayList ^sensorMax;

	SDHBackend(void);
	void init(ArrayList ^printBuffer);
	void connect();
	void printout(Object ^o);

	void openHandStart();
	void openHand();
	void printSensors();
	int getMaxPressure();
	void shutDown();


	void graspSearchStart();
	void graspSearch();
	void manualTriggerHit();
	void closeGrasp();
	void clearTargets();
	void closeProximalsStart();
	void closeProximals();
	void closeDistalsStart();
	void closeDistals();
	void calculateCentroid();
	void rotateFingersStart();
	void startStateMachine();
	int getContactingFingers();
	int getHitDistalPosition(SensorHit ^sensorHit);
	int getHandAxisFromSensor(int iSensor);
	int getHandAxisFromSensor(SensorHit ^sensorHit);
	int getGlobalXFromSensorHit(SensorHit ^sensorHit);
	double deg2rad(double deg);
	int getGlobalYFromSensorHit(SensorHit ^sensorHit);

};

