/*
 * SDHGUI.h
 * Main Windows Forms file. Has a bunch of VS generated code, and GUI Methods. Initialises backend
 * Author: Sølve Monteiro, (c) 2010
 * */

#pragma once
#include "SDHBackend.h"


namespace SDHGrip2 {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace System::Threading;
	using namespace System::Collections;

	/// <summary>
	/// Summary for SDGUI
	/// </summary>
	public ref class SDHGUI : public System::Windows::Forms::Form
	{
	public:

		Thread ^sensorThread, ^graspThread;
		//This object does most of the communication to the hardware.
		SDHBackend ^sdhbackend;
		int maxPressureValue;
		bool running;
	private: System::Windows::Forms::Timer^  printTimer;
	private: System::Windows::Forms::Label^  label1;
	private: System::Windows::Forms::Label^  label_maxPressure;
	private: System::Windows::Forms::Timer^  timer_maxPressurePoll;
	private: System::Windows::Forms::Button^  button3;
	private: System::Windows::Forms::Button^  button4;
	private: System::Windows::Forms::Button^  button5;
	private: System::Windows::Forms::TrackBar^  trackBar_changeThreshhold;

	private: System::Windows::Forms::Label^  label2;
	private: System::Windows::Forms::Label^  label_threshhold;
	private: System::Windows::Forms::Button^  button6;
	private: System::Windows::Forms::Button^  button7;
	private: System::Windows::Forms::Button^  button8;
	private: System::Windows::Forms::ProgressBar^  pb_0;
	private: System::Windows::Forms::ProgressBar^  pb_1;
	private: System::Windows::Forms::ProgressBar^  pb_3;
	private: System::Windows::Forms::ProgressBar^  pb_2;
	private: System::Windows::Forms::ProgressBar^  pb_5;
	private: System::Windows::Forms::ProgressBar^  pb_4;
	private: System::Windows::Forms::Label^  label3;
	private: System::Windows::Forms::Label^  label4;
	private: System::Windows::Forms::Label^  label5;
	private: System::Windows::Forms::Label^  label_state;


	public: 
		//Arraylist of objects to be printed out. Has to be passed through a buffer
		//since windows Forms cannot be accessed from other threads than parent
		ArrayList ^printBuffer;
		
		//Initialise some values
		SDHGUI(void)
		{
			maxPressureValue=0;
			running=true;
			InitializeComponent();

			printBuffer = gcnew ArrayList();
			printout("Form initialised");
			sdhbackend = gcnew SDHBackend();
			sdhbackend->init(printBuffer);
			
		}

		//Print method. Adds objects to buffer
		void printout(Object ^o){
			printBuffer->Add(o);
		}

		

	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~SDHGUI()
		{
			if (components)
			{
				delete components;
			}
		}
	private: System::Windows::Forms::Button^  button1;
	protected: 
	private: System::Windows::Forms::RichTextBox^  richTextBox1;
	private: System::Windows::Forms::Button^  button2;
	private: System::ComponentModel::IContainer^  components;

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>


#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->components = (gcnew System::ComponentModel::Container());
			this->button1 = (gcnew System::Windows::Forms::Button());
			this->richTextBox1 = (gcnew System::Windows::Forms::RichTextBox());
			this->button2 = (gcnew System::Windows::Forms::Button());
			this->printTimer = (gcnew System::Windows::Forms::Timer(this->components));
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->label_maxPressure = (gcnew System::Windows::Forms::Label());
			this->timer_maxPressurePoll = (gcnew System::Windows::Forms::Timer(this->components));
			this->button3 = (gcnew System::Windows::Forms::Button());
			this->button4 = (gcnew System::Windows::Forms::Button());
			this->button5 = (gcnew System::Windows::Forms::Button());
			this->trackBar_changeThreshhold = (gcnew System::Windows::Forms::TrackBar());
			this->label2 = (gcnew System::Windows::Forms::Label());
			this->label_threshhold = (gcnew System::Windows::Forms::Label());
			this->button6 = (gcnew System::Windows::Forms::Button());
			this->button7 = (gcnew System::Windows::Forms::Button());
			this->button8 = (gcnew System::Windows::Forms::Button());
			this->pb_0 = (gcnew System::Windows::Forms::ProgressBar());
			this->pb_1 = (gcnew System::Windows::Forms::ProgressBar());
			this->pb_3 = (gcnew System::Windows::Forms::ProgressBar());
			this->pb_2 = (gcnew System::Windows::Forms::ProgressBar());
			this->pb_5 = (gcnew System::Windows::Forms::ProgressBar());
			this->pb_4 = (gcnew System::Windows::Forms::ProgressBar());
			this->label3 = (gcnew System::Windows::Forms::Label());
			this->label4 = (gcnew System::Windows::Forms::Label());
			this->label5 = (gcnew System::Windows::Forms::Label());
			this->label_state = (gcnew System::Windows::Forms::Label());
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->trackBar_changeThreshhold))->BeginInit();
			this->SuspendLayout();
			// 
			// button1
			// 
			this->button1->Location = System::Drawing::Point(13, 26);
			this->button1->Name = L"button1";
			this->button1->Size = System::Drawing::Size(98, 23);
			this->button1->TabIndex = 0;
			this->button1->Text = L"Connect to HW";
			this->button1->UseVisualStyleBackColor = true;
			this->button1->Click += gcnew System::EventHandler(this, &SDHGUI::GUIConnect);
			// 
			// richTextBox1
			// 
			this->richTextBox1->Location = System::Drawing::Point(12, 238);
			this->richTextBox1->Name = L"richTextBox1";
			this->richTextBox1->Size = System::Drawing::Size(660, 219);
			this->richTextBox1->TabIndex = 1;
			this->richTextBox1->Text = L"";
			// 
			// button2
			// 
			this->button2->Location = System::Drawing::Point(13, 84);
			this->button2->Name = L"button2";
			this->button2->Size = System::Drawing::Size(84, 23);
			this->button2->TabIndex = 2;
			this->button2->Text = L"Open Hand";
			this->button2->UseVisualStyleBackColor = true;
			this->button2->Click += gcnew System::EventHandler(this, &SDHGUI::GUIOpenHand);
			// 
			// printTimer
			// 
			this->printTimer->Enabled = true;
			this->printTimer->Interval = 50;
			this->printTimer->Tick += gcnew System::EventHandler(this, &SDHGUI::printOutBuffer);
			// 
			// label1
			// 
			this->label1->AutoSize = true;
			this->label1->Location = System::Drawing::Point(407, 25);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(74, 13);
			this->label1->TabIndex = 3;
			this->label1->Text = L"Max Pressure:";
			// 
			// label_maxPressure
			// 
			this->label_maxPressure->AutoSize = true;
			this->label_maxPressure->Location = System::Drawing::Point(487, 25);
			this->label_maxPressure->Name = L"label_maxPressure";
			this->label_maxPressure->Size = System::Drawing::Size(13, 13);
			this->label_maxPressure->TabIndex = 4;
			this->label_maxPressure->Text = L"0";
			// 
			// timer_maxPressurePoll
			// 
			this->timer_maxPressurePoll->Enabled = true;
			this->timer_maxPressurePoll->Interval = 10;
			this->timer_maxPressurePoll->Tick += gcnew System::EventHandler(this, &SDHGUI::getMaxPressure);
			// 
			// button3
			// 
			this->button3->Location = System::Drawing::Point(103, 84);
			this->button3->Name = L"button3";
			this->button3->Size = System::Drawing::Size(97, 23);
			this->button3->TabIndex = 5;
			this->button3->Text = L"Grasp (Search)";
			this->button3->UseVisualStyleBackColor = true;
			this->button3->Click += gcnew System::EventHandler(this, &SDHGUI::StartSearchMode);
			// 
			// button4
			// 
			this->button4->Location = System::Drawing::Point(206, 84);
			this->button4->Name = L"button4";
			this->button4->Size = System::Drawing::Size(75, 23);
			this->button4->TabIndex = 6;
			this->button4->Text = L"Trigger hit";
			this->button4->UseVisualStyleBackColor = true;
			this->button4->Click += gcnew System::EventHandler(this, &SDHGUI::GUIManualHit);
			// 
			// button5
			// 
			this->button5->Location = System::Drawing::Point(596, 209);
			this->button5->Name = L"button5";
			this->button5->Size = System::Drawing::Size(75, 23);
			this->button5->TabIndex = 7;
			this->button5->Text = L"Clear Log";
			this->button5->UseVisualStyleBackColor = true;
			this->button5->Click += gcnew System::EventHandler(this, &SDHGUI::GUIClearLog);
			// 
			// trackBar_changeThreshhold
			// 
			this->trackBar_changeThreshhold->Location = System::Drawing::Point(410, 54);
			this->trackBar_changeThreshhold->Maximum = 500;
			this->trackBar_changeThreshhold->Name = L"trackBar_changeThreshhold";
			this->trackBar_changeThreshhold->Size = System::Drawing::Size(186, 45);
			this->trackBar_changeThreshhold->TabIndex = 8;
			this->trackBar_changeThreshhold->TickFrequency = 10;
			this->trackBar_changeThreshhold->Value = 20;
			this->trackBar_changeThreshhold->ValueChanged += gcnew System::EventHandler(this, &SDHGUI::GUIChangeThresshold);
			// 
			// label2
			// 
			this->label2->AutoSize = true;
			this->label2->Location = System::Drawing::Point(407, 38);
			this->label2->Name = L"label2";
			this->label2->Size = System::Drawing::Size(66, 13);
			this->label2->TabIndex = 9;
			this->label2->Text = L"Threshhold: ";
			// 
			// label_threshhold
			// 
			this->label_threshhold->AutoSize = true;
			this->label_threshhold->Location = System::Drawing::Point(487, 38);
			this->label_threshhold->Name = L"label_threshhold";
			this->label_threshhold->Size = System::Drawing::Size(19, 13);
			this->label_threshhold->TabIndex = 10;
			this->label_threshhold->Text = L"20";
			// 
			// button6
			// 
			this->button6->Location = System::Drawing::Point(13, 113);
			this->button6->Name = L"button6";
			this->button6->Size = System::Drawing::Size(98, 23);
			this->button6->TabIndex = 11;
			this->button6->Text = L"Close Proximals";
			this->button6->UseVisualStyleBackColor = true;
			this->button6->Click += gcnew System::EventHandler(this, &SDHGUI::GUICloseProximals);
			// 
			// button7
			// 
			this->button7->Location = System::Drawing::Point(13, 142);
			this->button7->Name = L"button7";
			this->button7->Size = System::Drawing::Size(98, 23);
			this->button7->TabIndex = 12;
			this->button7->Text = L"Close Distals";
			this->button7->UseVisualStyleBackColor = true;
			this->button7->Click += gcnew System::EventHandler(this, &SDHGUI::GUICloseDistals);
			// 
			// button8
			// 
			this->button8->Location = System::Drawing::Point(181, 26);
			this->button8->Name = L"button8";
			this->button8->Size = System::Drawing::Size(100, 23);
			this->button8->TabIndex = 13;
			this->button8->Text = L"Full Auto Grasp";
			this->button8->UseVisualStyleBackColor = true;
			this->button8->Click += gcnew System::EventHandler(this, &SDHGUI::GUIInitAutoGrasp);
			// 
			// pb_0
			// 
			this->pb_0->Location = System::Drawing::Point(352, 142);
			this->pb_0->Maximum = 3600;
			this->pb_0->Name = L"pb_0";
			this->pb_0->Size = System::Drawing::Size(100, 14);
			this->pb_0->Style = System::Windows::Forms::ProgressBarStyle::Continuous;
			this->pb_0->TabIndex = 14;
			// 
			// pb_1
			// 
			this->pb_1->Location = System::Drawing::Point(458, 142);
			this->pb_1->Maximum = 3600;
			this->pb_1->Name = L"pb_1";
			this->pb_1->Size = System::Drawing::Size(100, 14);
			this->pb_1->Style = System::Windows::Forms::ProgressBarStyle::Continuous;
			this->pb_1->TabIndex = 15;
			// 
			// pb_3
			// 
			this->pb_3->Location = System::Drawing::Point(458, 122);
			this->pb_3->Maximum = 3600;
			this->pb_3->Name = L"pb_3";
			this->pb_3->Size = System::Drawing::Size(100, 14);
			this->pb_3->Style = System::Windows::Forms::ProgressBarStyle::Continuous;
			this->pb_3->TabIndex = 17;
			// 
			// pb_2
			// 
			this->pb_2->Location = System::Drawing::Point(352, 122);
			this->pb_2->Maximum = 3600;
			this->pb_2->Name = L"pb_2";
			this->pb_2->Size = System::Drawing::Size(100, 14);
			this->pb_2->Style = System::Windows::Forms::ProgressBarStyle::Continuous;
			this->pb_2->TabIndex = 16;
			// 
			// pb_5
			// 
			this->pb_5->Location = System::Drawing::Point(458, 162);
			this->pb_5->Maximum = 3600;
			this->pb_5->Name = L"pb_5";
			this->pb_5->Size = System::Drawing::Size(100, 14);
			this->pb_5->Style = System::Windows::Forms::ProgressBarStyle::Continuous;
			this->pb_5->TabIndex = 19;
			// 
			// pb_4
			// 
			this->pb_4->Location = System::Drawing::Point(352, 162);
			this->pb_4->Maximum = 3600;
			this->pb_4->Name = L"pb_4";
			this->pb_4->Size = System::Drawing::Size(100, 14);
			this->pb_4->Style = System::Windows::Forms::ProgressBarStyle::Continuous;
			this->pb_4->TabIndex = 18;
			// 
			// label3
			// 
			this->label3->AutoSize = true;
			this->label3->Location = System::Drawing::Point(349, 190);
			this->label3->Name = L"label3";
			this->label3->Size = System::Drawing::Size(51, 13);
			this->label3->TabIndex = 20;
			this->label3->Text = L"Proximals";
			// 
			// label4
			// 
			this->label4->AutoSize = true;
			this->label4->Location = System::Drawing::Point(455, 190);
			this->label4->Name = L"label4";
			this->label4->Size = System::Drawing::Size(38, 13);
			this->label4->TabIndex = 21;
			this->label4->Text = L"Distals";
			// 
			// label5
			// 
			this->label5->AutoSize = true;
			this->label5->Location = System::Drawing::Point(12, 209);
			this->label5->Name = L"label5";
			this->label5->Size = System::Drawing::Size(38, 13);
			this->label5->TabIndex = 22;
			this->label5->Text = L"State: ";
			// 
			// label_state
			// 
			this->label_state->AutoSize = true;
			this->label_state->Location = System::Drawing::Point(56, 209);
			this->label_state->Name = L"label_state";
			this->label_state->Size = System::Drawing::Size(0, 13);
			this->label_state->TabIndex = 23;
			// 
			// SDHGUI
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(684, 469);
			this->Controls->Add(this->label_state);
			this->Controls->Add(this->label5);
			this->Controls->Add(this->label4);
			this->Controls->Add(this->label3);
			this->Controls->Add(this->pb_5);
			this->Controls->Add(this->pb_4);
			this->Controls->Add(this->pb_3);
			this->Controls->Add(this->pb_2);
			this->Controls->Add(this->pb_1);
			this->Controls->Add(this->pb_0);
			this->Controls->Add(this->button8);
			this->Controls->Add(this->button7);
			this->Controls->Add(this->button6);
			this->Controls->Add(this->label_threshhold);
			this->Controls->Add(this->label2);
			this->Controls->Add(this->trackBar_changeThreshhold);
			this->Controls->Add(this->button5);
			this->Controls->Add(this->button4);
			this->Controls->Add(this->button3);
			this->Controls->Add(this->label_maxPressure);
			this->Controls->Add(this->label1);
			this->Controls->Add(this->button2);
			this->Controls->Add(this->richTextBox1);
			this->Controls->Add(this->button1);
			this->Name = L"SDHGUI";
			this->Text = L"SDH Adaptive Gripping";
			this->FormClosing += gcnew System::Windows::Forms::FormClosingEventHandler(this, &SDHGUI::shutDown);
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->trackBar_changeThreshhold))->EndInit();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion
	
	
//Start the sensor-polling. Runs in a separate thread!	
public: void GUIPollSensors(){
		
		while (running){
				maxPressureValue = sdhbackend->getMaxPressure();
				Sleep(20);
		}
	}	
	
	//GUI Method. Initialise the connection to the hardware
	private: System::Void GUIConnect(System::Object^  sender, System::EventArgs^  e) {
				 sdhbackend->connect();
				 sensorThread = gcnew Thread(gcnew ThreadStart(this, &SDHGUI::GUIPollSensors ));
				 sensorThread->Start();
			 }
			 
	//GUI Method. Call backend to start opening the hand.
	private: System::Void GUIOpenHand(System::Object^  sender, System::EventArgs^  e) {
				sdhbackend->openHandStart();
			 }
	
	//Timer method. Takes the oldest element in buffer, removes it, and prints out its ToString
	private: System::Void printOutBuffer(System::Object^  sender, System::EventArgs^  e) {
				while(printBuffer->Count>0){
					richTextBox1->AppendText(printBuffer[0]->ToString()+"\n");
					richTextBox1->ScrollToCaret();
					printBuffer->RemoveAt(0);
				}
			 }

			 
	//Read out max pressure and print it to label and progressbars
	private: System::Void getMaxPressure(System::Object^  sender, System::EventArgs^  e) {
				label_maxPressure->Text = maxPressureValue.ToString();
				pb_0->Value = (int)(sdhbackend->sensorMax[0]);
				pb_1->Value = (int)(sdhbackend->sensorMax[1]);
				pb_2->Value = (int)(sdhbackend->sensorMax[2]);
				pb_3->Value = (int)(sdhbackend->sensorMax[3]);
				pb_4->Value = (int)(sdhbackend->sensorMax[4]);
				pb_5->Value = (int)(sdhbackend->sensorMax[5]);
				label_state->Text = sdhbackend->state;
			}


	//GUI Method. Flags to set whenever we shut down.
	private: System::Void shutDown(System::Object^  sender, System::Windows::Forms::FormClosingEventArgs^  e)    {
				running = false;
				sdhbackend->shutDown();
			}
	
	//GUI Method. Starts single search, non automated		
	private: System::Void StartSearchMode(System::Object^  sender, System::EventArgs^  e) {
			printout("GUI starting search!");
			 sdhbackend->graspSearchStart();
		 }
	
	//GUI Method. Triggers a manual hit. Should be useful to test aborting of threads	 
	private: System::Void GUIManualHit(System::Object^  sender, System::EventArgs^  e) {
			sdhbackend->manualTriggerHit();
		 }
		 
	//GUI Method. Clears the output log	 
	private: System::Void GUIClearLog(System::Object^  sender, System::EventArgs^  e) {
			 richTextBox1->Clear();
		 }
		 
	//GUI Method. Slider change to change the pressure threshold	 
	private: System::Void GUIChangeThresshold(System::Object^  sender, System::EventArgs^  e) {
			int iVal = trackBar_changeThreshhold->Value;
			label_threshhold->Text = iVal.ToString();
			sdhbackend->iPressureThreshhold = iVal;
		 }
	
	//GUI Method. Manually close the proximals. Non automated
	private: System::Void GUICloseProximals(System::Object^  sender, System::EventArgs^  e) {
			 Thread ^proximalsThread = gcnew Thread(gcnew ThreadStart(sdhbackend,&SDHBackend::closeProximalsStart));
			 proximalsThread->Start();
		 }

	//GUI Method. Manually close distal links. Non automated
	private: System::Void GUICloseDistals(System::Object^  sender, System::EventArgs^  e) {
			 Thread ^distalsThread = gcnew Thread(gcnew ThreadStart(sdhbackend, &SDHBackend::closeDistalsStart));
			 distalsThread->Start();
		 }
		 
	//GUI Method. Start the fully automated grasp
	private: System::Void GUIInitAutoGrasp(System::Object^  sender, System::EventArgs^  e) {
			printout("Starting state machine");
			Thread ^stateMachineThread = gcnew Thread(gcnew ThreadStart(sdhbackend, &SDHBackend::startStateMachine));
			stateMachineThread->Start();
		 }

	};


}

